function GGR2R2_adm(action)

global scale


switch action
   
   
case 'f gallery'
   h=findobj(gcbf,'Tag','f gallery');
   string=get(h,'String');
   val=get(h,'Value');
   title(['y = ' string{val}])
   GGR2R2_adm('update graphics')
   
   
case 'my fcn'
   GGR2R2_adm('update graphics')
   
   
case 'update graphics'
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   ZLim=get(gca,'ZLim');
   ha=findobj(gcbf,'Tag','a');
   hk=findobj(gcbf,'Tag','k');
   hl=findobj(gcbf,'Tag','l');
   a=eval(get(ha,'String'));
   k=eval(get(hk,'String'));
   l=eval(get(hl,'String'));
   t=0:1/200:1;
   t=t';
   ZLim=[min(t) max(t)];
   
   hf=findobj(gcbf,'Tag','f gallery');
   string=get(hf,'String');
   val=get(hf,'Value');
   ft=string{val};
   h=findobj(gcbf,'Tag','[x,y]=f(t)');
   if isempty(ft)
      set(h,'Visible','off')
   else
      f=eval(ft);
      set(h,'XData',f(:,1),'YData',f(:,2),'ZData',t,'Visible','on')
   end
   
   h=findobj(gcbf,'Tag','g(t)');
   gt=get(h,'String');
   h=findobj(gcbf,'Tag','[x,y]=g(t)');
   if isempty(gt)
      set(h,'Visible','off')
   else
      g=eval(gt);
      set(h,'XData',g(:,1),'YData',g(:,2),'ZData',t,'Visible','on')
   end
   
   set(gca,'ZLim',ZLim)
   rotate3d on
   
   title(['[ x, y ] = ' string{val}])
      
   
case 'a'
   GGR2R2_adm('update graphics')
   
   
case 'k'
   GGR2R2_adm('update graphics')
   
   
case 'm'
   GGR2R2_adm('update graphics')
   
   
case 'a slider'
   ha=findobj(gcbf,'Tag','a slider');
   a=get(ha,'Value');
   a=a*10;
   ha=findobj(gcbf,'Tag','a');
   set(ha,'String',num2str(a,'%1.1f'))
   GGR2R2_adm('update graphics')
   
   
case 'k slider'
   hk=findobj(gcbf,'Tag','k slider');
   k=get(hk,'Value');
   k=k*10;
   hk=findobj(gcbf,'Tag','k');
   set(hk,'String',num2str(k,'%1.1f'))
   GGR2R2_adm('update graphics')
   
   
case 'l slider'
   hl=findobj(gcbf,'Tag','l slider');
   l=get(hl,'Value');
   l=l*10;
   hl=findobj(gcbf,'Tag','l');
   set(hl,'String',num2str(l,'%1.1f'))
   GGR2R2_adm('update graphics')
   
   
case 'm slider'
   hm=findobj(gcbf,'Tag','m slider');
   m=get(hm,'Value');
   m=m*10;
   hm=findobj(gcbf,'Tag','m');
   set(hm,'String',num2str(m,'%1.1f'))
   GGR2R2_adm('update graphics')
   
   
case 'zoom in'
   scale=.5;
   GGR2R2_adm('set axis')
   
   
case 'zoom out'
   scale=2;
   GGR2R2_adm('set axis')

   
   
case 'view'
   hm=findobj(gcbf,'Tag','view');
   if get(hm,'String')=='phase plot'
      p=[-8.84146 -11.5224 8.88525];
      p0=[0 0 p(3)];
      cu=[0 0 1];
      cu0=[0 1 0];
      m='(3-2*i/16).*(i/16).^2';
      for i=1:16
         set(gca,'CameraPosition',p+(p0-p)*eval(m),...
                 'CameraUpVector',cu+(cu0-cu)*eval(m)) %sqrt(i)/4)
         drawnow
      end
      set(hm,'String',' 3D view  ')
   elseif get(hm,'String')==' 3D view  '
      p=[-8.84146 -11.5224 8.88525];
      p0=[0 0 p(3)];
      cu=[0 0 1];
      cu0=[0 1 0];
      m='(3-2*i/16).*(i/16).^2';
      for i=1:16
         set(gca,'CameraPosition',p0+(p-p0)*eval(m),...
                 'CameraUpVector',cu0+(cu-cu0)*eval(m))  %i^2/16^2,%i^2/16^2)

         drawnow
      end
      set(hm,'String','phase plot')
   end

   
case 'set axis'
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   ZLim=get(gca,'ZLim');
   dX=scale*diff(XLim);
   dY=scale*diff(YLim);
   dZ=scale*diff(ZLim);
   cp(1)=sum(XLim)/2;
   cp(2)=sum(YLim)/2;
   cp(3)=sum(ZLim)/2;
   NewXLim=[cp(1)-dX/2 cp(1)+dX/2];
   NewYLim=[cp(2)-dY/2 cp(2)+dY/2];
   NewZLim=[cp(3)-dZ/2 cp(3)+dZ/2];
   set(gca,'XLim',NewXLim,'YLim',NewYLim,'ZLim',NewZLim)
   GGR2R2_adm('update graphics')
   
   
case 'back'
   close(gcf)
   open('GG2.fig')
   
case 'close'
   close(gcf)
end
