function GG_adm(action)

global scale cp


switch action
   
   
case 'f gallery'
   h=findobj(gcbf,'Tag','f gallery');
   string=get(h,'String');
   val=get(h,'Value');
   title(['y = ' string{val}])
   GG_adm('update graphics')
   
   
case 'my fcn'
   GG_adm('update graphics')
   
   
case 'update graphics'
   XLim=get(gca,'XLim');
   dx=diff(XLim);
   YLim=get(gca,'YLim');
   x=XLim(1):dx/100:XLim(2);
   ha=findobj(gcbf,'Tag','a');
   hk=findobj(gcbf,'Tag','k');
   hm=findobj(gcbf,'Tag','m');
   a=eval(get(ha,'String'));
   k=eval(get(hk,'String'));
   m=eval(get(hm,'String'));
   
   hg=findobj(gcbf,'Tag','g(x)');
   gx=get(hg,'String');
   hg=findobj(gcbf,'Tag','y=g(x)');
   if isempty(gx)
      set(hg,'Visible','off')
   else
      g=eval(gx);
      set(hg,'XData',x,'YData',g,'Visible','on')
   end
   hf=findobj(gcbf,'Tag','f gallery');
   string=get(hf,'String');
   val=get(hf,'Value');
   fx=string{val};
   f=eval(fx).*ones(size(x));
   hg=findobj(gcbf,'Tag','y=f(x)');
   set(hg,'XData',x,'YData',f);
   hx=findobj(gcbf,'Tag','x_axis');
   set(hx,'XData',XLim)
   hy=findobj(gcbf,'Tag','y_axis');
   set(hy,'YData',YLim)
   return
   set(gca,'XLim',XLim,'YLim',YLim)
   title(string{val})
      
   
case 'a'
   GG_adm('update graphics')
   
   
case 'k'
   GG_adm('update graphics')
   
   
case 'm'
   GG_adm('update graphics')
   
   
case 'a slider'
   ha=findobj(gcbf,'Tag','a slider');
   a=get(ha,'Value');
   a=a*10;
   ha=findobj(gcbf,'Tag','a');
   set(ha,'String',num2str(a,'%1.1f'))
   GG_adm('update graphics')
   
   
case 'k slider'
   hk=findobj(gcbf,'Tag','k slider');
   k=get(hk,'Value');
   k=k*10;
   hk=findobj(gcbf,'Tag','k');
   set(hk,'String',num2str(k,'%1.1f'))
   GG_adm('update graphics')
   
   
case 'm slider'
   hm=findobj(gcbf,'Tag','m slider');
   m=get(hm,'Value');
   m=m*10;
   hm=findobj(gcbf,'Tag','m');
   set(hm,'String',num2str(m,'%1.1f'))
   GG_adm('update graphics')
   
   
case 'zoom in'
   set(gcbf,'WindowButtonDownFcn','GG_adm(''set axis'')')
   scale=.5;
   
   
case 'zoom out'
   set(gcbf,'WindowButtonDownFcn','GG_adm(''set axis'')')
   scale=2;
   
   
case 'refocus'
   set(gcbf,'WindowButtonDownFcn','GG_adm(''set axis'')')
   scale=1;
   
   
case 'set axis'
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dX=scale*diff(XLim);
   dY=scale*diff(YLim);
   NewXLim=[cp(1)-dX/2 cp(1)+dX/2];
   NewYLim=[cp(2)-dY/2 cp(2)+dY/2];
   set(gca,'XLim',NewXLim,'YLim',NewYLim)
   GG_adm('update graphics')
   
   
case 'drag'
   set(gcbf,'WindowButtonDownFcn','GG_adm(''start drag'')')
   
   
case 'start drag'
   set(gcbf,'WindowButtonMotionFcn','GG_adm(''drag it'')')
   set(gcbf,'WindowButtonUpFcn','GG_adm(''stop drag'')')
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);  
   
   
case 'drag it'
   newcp=get(gca,'CurrentPoint');
   newcp=newcp(1,1:2);
   dxy=newcp-cp;
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   XLim=XLim-dxy(1)/5;
   YLim=YLim-dxy(2)/5;
   set(gca,'XLim',XLim,'YLim',YLim)
   GG_adm('Update graphics')
   
   
case 'stop drag'
   set(gcbf,'WindowButtonMotionFcn','')
   set(gcbf,'WindowButtonUpFcn','')
   GG_adm('update graphics')
   
   
case 'lin'
   close(gcbf)
   open('GGlin.fig')
%  GGlin
   
case 'pol'
   close(gcbf)
   open('GGpol.fig')
%  GGpol
   
case 'trig'
   close(gcbf)
   open('GGtrig.fig')
%   GGtrig
   
case 'exp'
   close(gcbf)
   open('GGexp.fig')
%   GGexp
   
case 'mis'
   close(gcbf)
   open('GGmis.fig')
%   GGmis
   
case 'gen'
   close(gcbf)
   open('GGgen.fig')
%   GGgen
   
case '2nd floor'
   close(gcf)
   open('GG2.fig')
   
case 'close'
   close(gcf)
   
end
